/******************************************************************************
 THXExprEditor.h

	Interface for the THXExprEditor class

	Copyright  1998 by John Lindal. All rights reserved.

 ******************************************************************************/

#ifndef _H_THXExprEditor
#define _H_THXExprEditor

#include <JXExprEditor.h>

class JXStaticText;
class THXVarList;

class THXExprEditor : public JXExprEditor
{
public:

	THXExprEditor(const THXVarList* varList, JXMenuBar* menuBar,
				  JXStaticText* tapeWidget,
				  JXScrollbarSet* scrollbarSet, JXContainer* enclosure,
				  const HSizingOption hSizing, const VSizingOption vSizing,
				  const JCoordinate x, const JCoordinate y,
				  const JCoordinate w, const JCoordinate h);

	virtual ~THXExprEditor();

	virtual void	EvaluateSelection() const;

	virtual void	HandleKeyPress(const int key, const JXKeyModifiers& modifiers);

private:

	JXStaticText*	itsTapeWidget;	// not owned

private:

	// not allowed

	THXExprEditor(const THXExprEditor& source);
	const THXExprEditor& operator=(const THXExprEditor& source);
};

#endif
