/******************************************************************************
 THXPlotDirector.h

	Interface for the THXPlotDirector class

	Copyright  1998 by John Lindal. All rights reserved.

 ******************************************************************************/

#ifndef _H_THXPlotDirector
#define _H_THXPlotDirector

#include <JXWindowDirector.h>

class JFunction;
class JXImage;
class JXTextButton;
class JXTextMenu;
class JX2DPlotWidget;
class THXVarList;

class THXPlotDirector : public JXWindowDirector
{
public:

	THXPlotDirector(JXDirector* supervisor);
	THXPlotDirector(istream& input, const JFileVersion vers,
					JXDirector* supervisor, THXVarList* varList);

	virtual ~THXPlotDirector();

	void	AddFunction(THXVarList* varList, const JFunction& f,
						const JCharacter* name,
						const JFloat xMin, const JFloat xMax);

	void	WriteState(ostream& output) const;

protected:

	virtual void	Receive(JBroadcaster* sender, const Message& message);

private:

	const THXVarList*	itsVarList;
	JXTextMenu*			itsActionsMenu;
	JXTextMenu*			itsHelpMenu;

	JXImage*	itsWindowIcon;		// keep it so the colors won't get deallocated

// begin JXLayout

    JX2DPlotWidget* itsPlotWidget;
    JXTextButton*   itsCloseButton;

// end JXLayout

private:

	void	BuildWindow();
	void	AddFunction(THXVarList* varList, JFunction* f,
						const JCharacter* name,
						const JFloat xMin, const JFloat xMax);

	void	UpdateActionsMenu();
	void	HandleActionsMenu(const JIndex index);

	void	UpdateHelpMenu();
	void	HandleHelpMenu(const JIndex index);

	// not allowed

	THXPlotDirector(const THXPlotDirector& source);
	const THXPlotDirector& operator=(const THXPlotDirector& source);
};

#endif
