/******************************************************************************
 THXPlotFunctionDialog.h

	Interface for the THXPlotFunctionDialog class

	Copyright  1998 by John Lindal. All rights reserved.

 ******************************************************************************/

#ifndef _H_THXPlotFunctionDialog
#define _H_THXPlotFunctionDialog

#include <JXDialogDirector.h>

class JString;
class JFunction;
class JXTextMenu;
class JXInputField;
class JXFloatInput;
class JXExprEditor;
class THXPlotDirector;
class THXVarList;

class THXPlotFunctionDialog : public JXDialogDirector
{
public:

	THXPlotFunctionDialog(JXDirector* supervisor, const THXVarList* varList,
						  const THXPlotDirector* prevPlot = NULL);

	virtual ~THXPlotFunctionDialog();

	void	GetSettings(JIndex* plotIndex,
						const JFunction** f, JString* curveName,
						JFloat* fMin, JFloat* fMax) const;

protected:

	virtual JBoolean	OKToDeactivate();
	virtual void		Receive(JBroadcaster* sender, const Message& message);

private:

	JIndex			itsPlotIndex;
	JXExprEditor*	itsExprWidget;

// begin JXLayout

    JXTextMenu*   itsPlotMenu;
    JXInputField* itsCurveName;
    JXFloatInput* itsMinValue;
    JXFloatInput* itsMaxValue;

// end JXLayout

private:

	void	BuildWindow(const THXVarList* varList, const THXPlotDirector* prevPlot);

	// not allowed

	THXPlotFunctionDialog(const THXPlotFunctionDialog& source);
	const THXPlotFunctionDialog& operator=(const THXPlotFunctionDialog& source);
};

#endif
